{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "fedora:26"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#awk.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#awk.cwl/EXPRESSION",
                    "type": "string",
                    "inputBinding": {
                        "position": 0
                    }
                },
                {
                    "id": "#awk.cwl/OUTFILE",
                    "type": "string"
                }
            ],
            "stdout": "$(inputs.OUTFILE)",
            "baseCommand": [
                "awk"
            ],
            "id": "#awk.cwl",
            "outputs": [
                {
                    "id": "#awk.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.OUTFILE)"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/mirna-profiler:ce50c6e2c06f230f16bc84e8152f2b4e30749487db3a98a21989bfdc6823ee30"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.sam.basename)",
                            "entry": "$(inputs.sam)",
                            "writable": true
                        },
                        {
                            "entryname": "$(inputs.adapter_report.basename)",
                            "entry": "$(inputs.adapter_report)",
                            "writable": true
                        }
                    ]
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#mirna_alignment_stats.cwl/sam",
                    "format": "#mirna_alignment_stats.cwl/format_2573",
                    "type": "File"
                },
                {
                    "id": "#mirna_alignment_stats.cwl/adapter_report",
                    "type": "File"
                },
                {
                    "id": "#mirna_alignment_stats.cwl/project_directory",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "position": 93,
                        "prefix": "-p"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mirna_alignment_stats.cwl/alignment_stats_csv",
                    "type": "File",
                    "outputBinding": {
                        "glob": "alignment_stats.csv"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/features",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/chastity_taglengths_csv",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/chastity_taglengths.csv"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/crossmapped_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/crossmapped.txt"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/filtered_taglengths_csv",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/filtered_taglengths.csv"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/isoforms_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/isoforms.txt"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/miRNA_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/miRNA.txt"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/mirna_species_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/mirna_species.txt"
                    }
                },
                {
                    "id": "#mirna_alignment_stats.cwl/softclip_taglengths_csv",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/softclip_taglengths.csv"
                    }
                }
            ],
            "baseCommand": [
                "/usr/mirna/v0.2.7/code/library_stats/alignment_stats.pl"
            ],
            "id": "#mirna_alignment_stats.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/mirna-profiler:ce50c6e2c06f230f16bc84e8152f2b4e30749487db3a98a21989bfdc6823ee30"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.sam.basename)",
                            "entry": "$(inputs.sam)",
                            "writable": true
                        }
                    ]
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#mirna_annotate.cwl/sam",
                    "format": "#mirna_annotate.cwl/format_2573",
                    "type": "File"
                },
                {
                    "id": "#mirna_annotate.cwl/mirbase",
                    "type": "string",
                    "default": "hg38",
                    "inputBinding": {
                        "position": 90,
                        "prefix": "-m",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_annotate.cwl/ucsc_database",
                    "type": "string",
                    "default": "hg38",
                    "inputBinding": {
                        "position": 91,
                        "prefix": "-u",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_annotate.cwl/species_code",
                    "type": "string",
                    "default": "hsa",
                    "inputBinding": {
                        "position": 92,
                        "prefix": "-o",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_annotate.cwl/project_directory",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "position": 93,
                        "prefix": "-p",
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mirna_annotate.cwl/output",
                    "format": "#mirna_annotate.cwl/format_2573",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.basename)"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "chmod 1777 /tmp",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& sudo /usr/sbin/mysqld --defaults-file=/etc/mysql/my.cnf --user=mysql --daemonize",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& /usr/mirna/v0.2.7/code/annotation/annotate.pl",
                    "position": 3,
                    "shellQuote": false
                }
            ],
            "baseCommand": [],
            "id": "#mirna_annotate.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/mirna-profiler:ce50c6e2c06f230f16bc84e8152f2b4e30749487db3a98a21989bfdc6823ee30"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.stats_mirna_species_txt.basename)",
                            "entry": "$(inputs.stats_mirna_species_txt)"
                        }
                    ]
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#mirna_expression_matrix.cwl/mirbase_db",
                    "type": "string",
                    "default": "hg38",
                    "inputBinding": {
                        "position": 90,
                        "prefix": "-m",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_expression_matrix.cwl/project_directory",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "position": 93,
                        "prefix": "-p",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_expression_matrix.cwl/species_code",
                    "type": "string",
                    "default": "hsa",
                    "inputBinding": {
                        "position": 92,
                        "prefix": "-o",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_expression_matrix.cwl/stats_mirna_species_txt",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#mirna_expression_matrix.cwl/expn_matrix_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "expn_matrix.txt"
                    }
                },
                {
                    "id": "#mirna_expression_matrix.cwl/expn_matrix_norm_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "expn_matrix_norm.txt"
                    }
                },
                {
                    "id": "#mirna_expression_matrix.cwl/expn_matrix_norm_log_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "expn_matrix_norm_log.txt"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "sudo chmod 1777 /tmp",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& sudo /usr/sbin/mysqld --defaults-file=/etc/mysql/my.cnf --user=mysql --daemonize",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& /usr/mirna/v0.2.7/code/library_stats/expression_matrix.pl",
                    "position": 3,
                    "shellQuote": false
                }
            ],
            "baseCommand": [],
            "id": "#mirna_expression_matrix.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/mirna-profiler:ce50c6e2c06f230f16bc84e8152f2b4e30749487db3a98a21989bfdc6823ee30"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.stats_crossmapped_txt.basename)",
                            "entry": "$(inputs.stats_crossmapped_txt)"
                        },
                        {
                            "entryname": "$(inputs.stats_mirna_txt.basename)",
                            "entry": "$(inputs.stats_mirna_txt)"
                        }
                    ]
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/mirbase_db",
                    "type": "string",
                    "default": "hg38",
                    "inputBinding": {
                        "position": 90,
                        "prefix": "-m",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/project_directory",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "position": 91,
                        "prefix": "-p",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/species_code",
                    "type": "string",
                    "default": "hsa",
                    "inputBinding": {
                        "position": 92,
                        "prefix": "-o",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/stats_crossmapped_txt",
                    "type": "File"
                },
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/stats_mirna_txt",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/expn_matrix_mimat_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "expn_matrix_mimat.txt"
                    }
                },
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/expn_matrix_mimat_norm_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "expn_matrix_mimat_norm.txt"
                    }
                },
                {
                    "id": "#mirna_expression_matrix_mimat.cwl/expn_matrix_mimat_norm_log_txt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "expn_matrix_mimat_norm_log.txt"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "sudo chmod 1777 /tmp",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& sudo /usr/sbin/mysqld --defaults-file=/etc/mysql/my.cnf --user=mysql --daemonize",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& /usr/mirna/v0.2.7/code/library_stats/expression_matrix_mimat.pl",
                    "position": 3,
                    "shellQuote": false
                }
            ],
            "baseCommand": [],
            "id": "#mirna_expression_matrix_mimat.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/mirna-profiler:ce50c6e2c06f230f16bc84e8152f2b4e30749487db3a98a21989bfdc6823ee30"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.sam.basename)",
                            "entry": "$(inputs.sam)"
                        },
                        {
                            "entryname": "$(inputs.adapter_report.basename)",
                            "entry": "$(inputs.adapter_report)"
                        },
                        {
                            "entryname": "$(inputs.alignment_stats_csv.basename)",
                            "entry": "$(inputs.alignment_stats_csv)"
                        },
                        {
                            "entryname": "$(inputs.chastity_taglengths_csv.basename)",
                            "entry": "$(inputs.chastity_taglengths_csv)"
                        },
                        {
                            "entryname": "$(inputs.filtered_taglengths_csv.basename)",
                            "entry": "$(inputs.filtered_taglengths_csv)"
                        },
                        {
                            "entryname": "$(inputs.softclip_taglengths_csv.basename)",
                            "entry": "$(inputs.softclip_taglengths_csv)"
                        }
                    ]
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#mirna_graph_libs.cwl/sam",
                    "type": "File"
                },
                {
                    "id": "#mirna_graph_libs.cwl/adapter_report",
                    "type": "File"
                },
                {
                    "id": "#mirna_graph_libs.cwl/alignment_stats_csv",
                    "type": "File"
                },
                {
                    "id": "#mirna_graph_libs.cwl/chastity_taglengths_csv",
                    "type": "File"
                },
                {
                    "id": "#mirna_graph_libs.cwl/filtered_taglengths_csv",
                    "type": "File"
                },
                {
                    "id": "#mirna_graph_libs.cwl/softclip_taglengths_csv",
                    "type": "File"
                },
                {
                    "id": "#mirna_graph_libs.cwl/project_directory",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "position": 90,
                        "prefix": "-p",
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mirna_graph_libs.cwl/jpgs",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features"
                    }
                }
            ],
            "baseCommand": [
                "/usr/mirna/v0.2.7/code/library_stats/graph_libs.pl"
            ],
            "id": "#mirna_graph_libs.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/mirna-profiler:ce50c6e2c06f230f16bc84e8152f2b4e30749487db3a98a21989bfdc6823ee30"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.sam.basename)",
                            "entry": "$(inputs.sam)"
                        },
                        {
                            "entryname": "$(inputs.stats_miRNA_txt.basename)",
                            "entry": "$(inputs.stats_miRNA_txt)"
                        },
                        {
                            "entryname": "$(inputs.stats_crossmapped_txt.basename)",
                            "entry": "$(inputs.stats_crossmapped_txt)"
                        },
                        {
                            "entryname": "$(inputs.stats_isoforms_txt.basename)",
                            "entry": "$(inputs.stats_isoforms_txt)"
                        }
                    ]
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#mirna_tcga.cwl/genome_version",
                    "type": "string",
                    "default": "hg38",
                    "inputBinding": {
                        "position": 90,
                        "prefix": "-g",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_tcga.cwl/mirbase_db",
                    "type": "string",
                    "default": "hg38",
                    "inputBinding": {
                        "position": 91,
                        "prefix": "-m",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_tcga.cwl/project_directory",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "position": 92,
                        "prefix": "-p",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_tcga.cwl/species_code",
                    "type": "string",
                    "default": "hsa",
                    "inputBinding": {
                        "position": 93,
                        "prefix": "-o",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mirna_tcga.cwl/sam",
                    "format": "#mirna_tcga.cwl/format_2573",
                    "type": "File"
                },
                {
                    "id": "#mirna_tcga.cwl/stats_miRNA_txt",
                    "type": "File"
                },
                {
                    "id": "#mirna_tcga.cwl/stats_crossmapped_txt",
                    "type": "File"
                },
                {
                    "id": "#mirna_tcga.cwl/stats_isoforms_txt",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#mirna_tcga.cwl/isoforms_quant",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/tcga/isoforms.txt"
                    }
                },
                {
                    "id": "#mirna_tcga.cwl/mirnas_quant",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sam.nameroot)_features/tcga/mirnas.txt"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "sudo chmod 1777 /tmp",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& sudo /usr/sbin/mysqld --defaults-file=/etc/mysql/my.cnf --user=mysql --daemonize",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&& /usr/mirna/v0.2.7/code/custom_output/tcga/tcga.pl",
                    "position": 3,
                    "shellQuote": false
                }
            ],
            "baseCommand": [],
            "id": "#mirna_tcga.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools:147bd4cc606a63c7435907d97fea6e94e9ea9ed58c18f390cab8bc40b1992df7"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_view.cwl/INPUT",
                    "format": "#samtools_view.cwl/format_2572",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                },
                {
                    "id": "#samtools_view.cwl/header_included",
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "-h"
                    }
                },
                {
                    "id": "#samtools_view.cwl/output_format",
                    "type": "string",
                    "default": "BAM",
                    "inputBinding": {
                        "prefix": "--output-fmt"
                    }
                },
                {
                    "id": "#samtools_view.cwl/threads",
                    "type": "long",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--threads"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_view.cwl/OUTPUT",
                    "format": "#samtools_view.cwl/format_2573",
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  return inputs.INPUT.nameroot + \".\" + inputs.output_format.toLowerCase();\n}\n"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  return inputs.INPUT.nameroot + \".\" + inputs.output_format.toLowerCase();\n}\n",
                    "prefix": "-o"
                }
            ],
            "baseCommand": [
                "/usr/local/bin/samtools",
                "view"
            ],
            "id": "#samtools_view.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "fedora:26"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#sort.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#sort.cwl/key",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--key=",
                        "separate": false
                    }
                },
                {
                    "id": "#sort.cwl/field-separator",
                    "type": "string",
                    "default": " ",
                    "inputBinding": {
                        "prefix": "--field-separator=",
                        "separate": false
                    }
                },
                {
                    "id": "#sort.cwl/OUTFILE",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#sort.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.OUTFILE)"
                    }
                }
            ],
            "stdout": "$(inputs.OUTFILE)",
            "baseCommand": [
                "sort"
            ],
            "id": "#sort.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/awk_expression",
                    "type": "string"
                },
                {
                    "id": "#main/bam",
                    "type": "File"
                },
                {
                    "id": "#main/mirbase_db",
                    "type": "string"
                },
                {
                    "id": "#main/species_code",
                    "type": "string"
                },
                {
                    "id": "#main/project_directory",
                    "type": "string"
                },
                {
                    "id": "#main/ucsc_database",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#main/mirna_adapter_report_sorted_output",
                    "type": "File",
                    "outputSource": "#main/mirna_adapter_report_sorted/OUTPUT"
                },
                {
                    "id": "#main/mirna_alignment_stats_features",
                    "type": "Directory",
                    "outputSource": "#main/mirna_alignment_stats/features"
                },
                {
                    "id": "#main/mirna_expression_matrix_expn_matrix_txt",
                    "type": "File",
                    "outputSource": "#main/mirna_expression_matrix/expn_matrix_txt"
                },
                {
                    "id": "#main/mirna_expression_matrix_expn_matrix_norm_txt",
                    "type": "File",
                    "outputSource": "#main/mirna_expression_matrix/expn_matrix_norm_txt"
                },
                {
                    "id": "#main/mirna_expression_matrix_expn_matrix_norm_log_txt",
                    "type": "File",
                    "outputSource": "#main/mirna_expression_matrix/expn_matrix_norm_log_txt"
                },
                {
                    "id": "#main/mirna_expression_matrix_mimat_expn_matrix_mimat_txt",
                    "type": "File",
                    "outputSource": "#main/mirna_expression_matrix_mimat/expn_matrix_mimat_txt"
                },
                {
                    "id": "#main/mirna_expression_matrix_mimat_expn_matrix_mimat_norm_txt",
                    "type": "File",
                    "outputSource": "#main/mirna_expression_matrix_mimat/expn_matrix_mimat_norm_txt"
                },
                {
                    "id": "#main/mirna_expression_matrix_mimat_expn_matrix_mimat_norm_log_txt",
                    "type": "File",
                    "outputSource": "#main/mirna_expression_matrix_mimat/expn_matrix_mimat_norm_log_txt"
                },
                {
                    "id": "#main/mirna_graph_libs_jpgs",
                    "type": "Directory",
                    "outputSource": "#main/mirna_graph_libs/jpgs"
                },
                {
                    "id": "#main/mirna_tcga_isoforms_quant",
                    "type": "File",
                    "outputSource": "#main/mirna_tcga/isoforms_quant"
                },
                {
                    "id": "#main/mirna_tcga_mirnas_quant",
                    "type": "File",
                    "outputSource": "#main/mirna_tcga/mirnas_quant"
                }
            ],
            "steps": [
                {
                    "id": "#main/samtools_bamtosam",
                    "run": "#samtools_view.cwl",
                    "in": [
                        {
                            "id": "#main/samtools_bamtosam/INPUT",
                            "source": "#main/bam"
                        },
                        {
                            "id": "#main/samtools_bamtosam/output_format",
                            "valueFrom": "SAM"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/samtools_bamtosam/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_adapter_report",
                    "run": "#awk.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_adapter_report/INPUT",
                            "source": "#main/samtools_bamtosam/OUTPUT"
                        },
                        {
                            "id": "#main/mirna_adapter_report/EXPRESSION",
                            "source": "#main/awk_expression"
                        },
                        {
                            "id": "#main/mirna_adapter_report/OUTFILE",
                            "source": "#main/samtools_bamtosam/OUTPUT",
                            "valueFrom": "$(self.nameroot)_adapter.report"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_adapter_report/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_adapter_report_sorted",
                    "run": "#sort.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_adapter_report_sorted/INPUT",
                            "source": "#main/mirna_adapter_report/OUTPUT"
                        },
                        {
                            "id": "#main/mirna_adapter_report_sorted/key",
                            "valueFrom": "1n"
                        },
                        {
                            "id": "#main/mirna_adapter_report_sorted/OUTFILE",
                            "source": "#main/mirna_adapter_report/OUTPUT",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_adapter_report_sorted/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_annotate",
                    "run": "#mirna_annotate.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_annotate/sam",
                            "source": "#main/samtools_bamtosam/OUTPUT"
                        },
                        {
                            "id": "#main/mirna_annotate/mirbase",
                            "source": "#main/mirbase_db"
                        },
                        {
                            "id": "#main/mirna_annotate/ucsc_database",
                            "source": "#main/ucsc_database"
                        },
                        {
                            "id": "#main/mirna_annotate/species_code",
                            "source": "#main/species_code"
                        },
                        {
                            "id": "#main/mirna_annotate/project_directory",
                            "source": "#main/project_directory"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_annotate/output"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_alignment_stats",
                    "run": "#mirna_alignment_stats.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_alignment_stats/adapter_report",
                            "source": "#main/mirna_adapter_report_sorted/OUTPUT"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/sam",
                            "source": "#main/mirna_annotate/output"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/project_directory",
                            "source": "#main/project_directory"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_alignment_stats/features"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/alignment_stats_csv"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/chastity_taglengths_csv"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/crossmapped_txt"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/filtered_taglengths_csv"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/isoforms_txt"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/miRNA_txt"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/mirna_species_txt"
                        },
                        {
                            "id": "#main/mirna_alignment_stats/softclip_taglengths_csv"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_tcga",
                    "run": "#mirna_tcga.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_tcga/genome_version",
                            "source": "#main/ucsc_database"
                        },
                        {
                            "id": "#main/mirna_tcga/mirbase_db",
                            "source": "#main/mirbase_db"
                        },
                        {
                            "id": "#main/mirna_tcga/project_directory",
                            "source": "#main/project_directory"
                        },
                        {
                            "id": "#main/mirna_tcga/species_code",
                            "source": "#main/species_code"
                        },
                        {
                            "id": "#main/mirna_tcga/sam",
                            "source": "#main/mirna_annotate/output"
                        },
                        {
                            "id": "#main/mirna_tcga/stats_miRNA_txt",
                            "source": "#main/mirna_alignment_stats/miRNA_txt"
                        },
                        {
                            "id": "#main/mirna_tcga/stats_crossmapped_txt",
                            "source": "#main/mirna_alignment_stats/crossmapped_txt"
                        },
                        {
                            "id": "#main/mirna_tcga/stats_isoforms_txt",
                            "source": "#main/mirna_alignment_stats/isoforms_txt"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_tcga/isoforms_quant"
                        },
                        {
                            "id": "#main/mirna_tcga/mirnas_quant"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_expression_matrix",
                    "run": "#mirna_expression_matrix.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_expression_matrix/mirbase_db",
                            "source": "#main/mirbase_db"
                        },
                        {
                            "id": "#main/mirna_expression_matrix/project_directory",
                            "source": "#main/project_directory"
                        },
                        {
                            "id": "#main/mirna_expression_matrix/species_code",
                            "source": "#main/species_code"
                        },
                        {
                            "id": "#main/mirna_expression_matrix/stats_mirna_species_txt",
                            "source": "#main/mirna_alignment_stats/mirna_species_txt"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_expression_matrix/expn_matrix_txt"
                        },
                        {
                            "id": "#main/mirna_expression_matrix/expn_matrix_norm_txt"
                        },
                        {
                            "id": "#main/mirna_expression_matrix/expn_matrix_norm_log_txt"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_expression_matrix_mimat",
                    "run": "#mirna_expression_matrix_mimat.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_expression_matrix_mimat/mirbase_db",
                            "source": "#main/mirbase_db"
                        },
                        {
                            "id": "#main/mirna_expression_matrix_mimat/project_directory",
                            "source": "#main/project_directory"
                        },
                        {
                            "id": "#main/mirna_expression_matrix_mimat/species_code",
                            "source": "#main/species_code"
                        },
                        {
                            "id": "#main/mirna_expression_matrix_mimat/stats_crossmapped_txt",
                            "source": "#main/mirna_alignment_stats/crossmapped_txt"
                        },
                        {
                            "id": "#main/mirna_expression_matrix_mimat/stats_mirna_txt",
                            "source": "#main/mirna_alignment_stats/miRNA_txt"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_expression_matrix_mimat/expn_matrix_mimat_txt"
                        },
                        {
                            "id": "#main/mirna_expression_matrix_mimat/expn_matrix_mimat_norm_txt"
                        },
                        {
                            "id": "#main/mirna_expression_matrix_mimat/expn_matrix_mimat_norm_log_txt"
                        }
                    ]
                },
                {
                    "id": "#main/mirna_graph_libs",
                    "run": "#mirna_graph_libs.cwl",
                    "in": [
                        {
                            "id": "#main/mirna_graph_libs/sam",
                            "source": "#main/mirna_annotate/output"
                        },
                        {
                            "id": "#main/mirna_graph_libs/adapter_report",
                            "source": "#main/mirna_adapter_report_sorted/OUTPUT"
                        },
                        {
                            "id": "#main/mirna_graph_libs/alignment_stats_csv",
                            "source": "#main/mirna_alignment_stats/alignment_stats_csv"
                        },
                        {
                            "id": "#main/mirna_graph_libs/chastity_taglengths_csv",
                            "source": "#main/mirna_alignment_stats/chastity_taglengths_csv"
                        },
                        {
                            "id": "#main/mirna_graph_libs/filtered_taglengths_csv",
                            "source": "#main/mirna_alignment_stats/filtered_taglengths_csv"
                        },
                        {
                            "id": "#main/mirna_graph_libs/softclip_taglengths_csv",
                            "source": "#main/mirna_alignment_stats/softclip_taglengths_csv"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mirna_graph_libs/jpgs"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
